<template>
  <div class="row top-position justify-content-center">
    <div class="col-md-8">
      <div class="card card-default">
        <div class="card-header">
          <div class="row">
            <div class="col-2">
              <button @click="viewCreateProject()" class="btn btn-add">create new</button>
            </div>
            <div class="col-10">
              <b-pagination
                v-model="currentPage"
                :per-page="perPage"
                aria-controls="my-table"
                align="right"
                pills
                :total-rows="rows"
                size="md"
              ></b-pagination>
            </div>
          </div>
        </div>
        <div class="card-body scrollbar overflow-hompage">
          <b-table
            id="my-table"
            :items="getProjects"
            :per-page="perPage"
            :current-page="currentPage"
            :fields="fields"
            small
            hover
          >
            <template v-slot:cell(actions)="row">
              <b-button size="sm" @click="viewProject(row.item.id)" class="btn btn-manage">
                <i class="fa fa-gears" style="font-size:0.9rem;"></i>
                Manage
              </b-button>
              <b-button size="sm" @click="getEditProject(row.item.id)" class="btn btn-edit">
                <i class="fa fa-edit" style="font-size:0.9rem;"></i>
                edit
              </b-button>
              <b-button size="sm" @click="getDeleteProject(row.item.id)" v-b-modal.delete-project class="btn btn-delete">
                <i class="fa fa-trash-o" style="font-size:0.9rem;"></i>
                delete
              </b-button>
            </template>
          </b-table>
        </div>
      </div>
    </div>
<!-- view project -->
    <b-modal ref="modal-view" id="view-project" size="lg" hide-footer hide-header style="position: absolute;" v-slot:default="{ hide }">
      <h2 class="t-color-red" align="center">Manage Project</h2><hr><div class="space-1"/>
      <h4 class="t-color-red" align="center"> Management project {{getViewProject.projectTitle}}</h4><div class="space-1"/>
      <h6 class="t-color-soft-gray" align="center"> Please click button below.</h6>
      <hr>
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">
        cancel
      </button>
      <router-link :to="'/project-view/' + getViewProject.id" size="sm" v-on:click="deleteProject" class="btn btn-delete t-uppercase f-right" @click="hide()">
        Start to manage
      </router-link>
    </b-modal>
<!-- create project -->
    <b-modal ref="create-project" id="create-project" size="lg" hide-footer hide-header style="position: absolute;">
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Create New Project</h2>
            <hr />
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input type="text" ref="projectTitle" v-model="projectTitle" required="required" v-once/>
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Title</label>
                <div class="row absolute">
                  <h6 v-if="projectTitle === ''" class="t-validate-div t-color-red col-12 right"><i class="fa fa-exclamation-circle"/> Project title is required</h6>
                  <h6 v-if="projectTitle !== ''" class="t-validate-div t-color-green col-12 right"><i class="fa fa-check-circle"/> Correct</h6>
                </div>
              </div>
              <div class="group">
                <textarea type="textarea" ref="projectDetail" class="scrollbar" rows="3" v-model="projectDetail" required="required" v-once/>
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Detail</label>
                <div class="row absolute">
                  <h6 v-if="projectDetail === ''" class="t-validate-div t-color-red col-12 right"><i class="fa fa-exclamation-circle"/> Project detail is required</h6>
                  <h6 v-if="projectDetail !== ''" class="t-validate-div t-color-green col-12 right"><i class="fa fa-check-circle"/> Correct</h6>
                </div>
              </div>
              <div class="row">
                <div class="col-6">
                  <input type="date" ref="start" v-model="start" required="required" v-once/>
                  <span class="bar" placeholder="false"></span>
                  <label>Start</label>
                  <div class="row absolute">
                    <h6 v-if="start === ''" class="t-validate-div t-color-red col-12 right"><i class="fa fa-exclamation-circle"/> Date to start is required</h6>
                    <h6 v-if="start !== ''" class="t-validate-div t-color-green col-12 right"><i class="fa fa-check-circle"/> Correct</h6>
                  </div>
                </div>
                <div class="col-6">
                  <input type="date" ref="end" v-model="end" required="required" v-once/>
                  <span class="bar" placeholder="false"></span>
                  <label>End</label>
                  <div class="row absolute">
                    <h6 v-if="end === ''" class="t-validate-div t-color-red col-12 right"><i class="fa fa-exclamation-circle"/> Date to end is required</h6>
                    <h6 v-if="end !== ''" class="t-validate-div t-color-green col-12 right"><i class="fa fa-check-circle"/> Correct</h6>
                  </div>
                </div>
              </div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button size="sm" v-on:click="createProject" class="btn btn-delete position-send-in-modal">
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- edit project -->
    <b-modal ref="modal-edit" id="edit-project" size="lg" hide-footer hide-header style="position: absolute;" v-slot:default="{ hide }">
      <form>
        <div class="row">
          <div class="col-12">
            <h2 class="t-color-red" align="center">Edit Project</h2>
            <hr>
          </div>
          <div class="col-12 row">
            <div class="col-2" />
            <div class="col-8">
              <div class="group">
                <input type="text" v-model="editProject.projectTitle" required="required"/>
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Title</label>
                <h6 v-if="(editProject.projectTitle === '')" class="t-validate t-color-red"><i class="fa fa-exclamation-circle"/> Project ttitle is required</h6>
              </div>
              <div class="group">
                <textarea type="textarea" class="scrollbar" rows="3" v-model="editProject.projectDetail" required="required" />
                <span class="highlight"></span>
                <span class="bar"></span>
                <label>Project Detail</label>
                <h6 v-if="(editProject.projectDetail === '')" class="t-validate t-color-red"><i class="fa fa-exclamation-circle"/> Project detail is required</h6>
              </div>
              <div class="row">
                <div class="col-6">
                  <input type="date" v-model="editProject.start" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>Start</label>
                  <h6 v-if="(editProject.start === '')" class="t-validate t-color-red"><i class="fa fa-exclamation-circle"/> Date to start is required</h6>
                </div>
                <div class="col-6">
                  <input type="date" v-model="editProject.end" required="required" />
                  <span class="bar" placeholder="false"></span>
                  <label>End</label>
                  <h6 v-if="(editProject.end === '')" class="t-validate t-color-red"><i class="fa fa-exclamation-circle"/> Date to end is required</h6>
                </div>
              </div>
              <div class="space-1" />
            </div>
          </div>
        </div>
        <button size="sm" v-on:click="updateProject" class="btn btn-delete position-send-in-modal" @click="hide()">
          <i class="fa fa-check" style="font-size:1.5rem;"></i>
        </button>
      </form>
    </b-modal>
<!-- delete project -->
    <b-modal ref="modal" id="delete-project" size="lg" hide-footer hide-header style="position: absolute;" v-slot:default="{ hide }">
      <h2 class="t-color-red" align="center">Delete Project</h2><hr><div class="space-1"/>
      <h4 class="t-color-red" align="center"> Are You sure?</h4><div class="space-1"/>
      <h6 class="t-color-soft-gray" align="center"> Do you really want to delete this project.</h6>
      <hr>
      <button size="sm" class="btn btn-delete t-uppercase" @click="hide()">
        cancel
      </button>
      <button size="sm" v-on:click="deleteProject" class="btn btn-delete t-uppercase f-right" @click="hide()">
        confirm
      </button>
    </b-modal>
<!-- alert -->
    <b-alert
      :show="success"
      variant="success"
      @dismissed="successCountDown=0"
      @dismiss-count-down="SuccessCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-check-circle"/> {{massage}}
    </b-alert>
    <b-alert
      :show="error"
      variant="danger"
      @dismissed="errorCountDown=0"
      @dismiss-count-down="ErrorCountDownChanged"
      fade
      class="alert-top"
    >
    <i class="fa fa-exclamation-circle"/> {{massage}}
    </b-alert>
  </div>
</template>
<script>
export default {
  mounted () {
    if (!this.$cookie.get('token')) {
      this.$router.push('/signin')
    }
    if (this.$cookie.get('role') !== 'Admin') {
      this.$router.push('/ProjectBlockList')
    }
    this.getData()
  },
  methods: {
    getData () {
      this.axios.get('api/projectList').then(response => {
        this.getProjects = response.data
      })
    },
    viewProject (info) {
      this.modalViewProjectId = JSON.stringify(info, null, 2)
      this.axios.get('api/showProject/' + this.modalViewProjectId).then(response => {
        this.getViewProject = response.data
        this.$refs['modal-view'].show()
      })
    },
    viewCreateProject () {
      this.projectTitle = ''
      this.projectDetail = ''
      this.start = ''
      this.end = ''
      this.$refs['create-project'].show()
    },
    createProject: function (e) {
      e.preventDefault()
      this.axios.post('api/createProject', {
        projectTitle: this.projectTitle,
        projectDetail: this.projectDetail,
        start: this.start,
        end: this.end
      })
        .then(response => {
          console.log(response)
          this.$refs['create-project'].hide()
          this.showAlertCreateProject()
        })
        .catch(error => {
          this.$refs['create-project'].hide()
          this.showAlertErrorCreateProject()
          console.log(error)
        })
      this.getData()
      this.projectTitle = ''
      this.projectDetail = ''
      this.start = ''
      this.end = ''
    },
    getEditProject (projectId) {
      this.modalEdit.projectId = JSON.stringify(projectId, null, 2)
      this.axios.get('api/editProject/' + this.modalEdit.projectId).then(response => {
        this.editProject = response.data
        console.log('test')
        console.log(this.editProject)
        this.$refs['modal-edit'].show()
      })
    },
    updateProject: function (e) {
      e.preventDefault()
      this.axios.put('api/updateProject/' + this.modalEdit.projectId, {
        projectTitle: this.editProject.projectTitle,
        projectDetail: this.editProject.projectDetail,
        start: this.editProject.start,
        end: this.editProject.end
      })
        .then(response => {
          console.log(response)
          this.showAlertUpdateProject()
        })
        .catch(error => {
          console.log(error)
          this.showAlertErrorCreateProject()
        })
      this.getData()
    },
    getDeleteProject (projectId) {
      this.modalDelete.projectId = JSON.stringify(projectId, null, 2)
      console.log(this.modalDelete.projectId)
    },
    deleteProject (projectId) {
      this.axios.put('api/destroyProject/' + this.modalDelete.projectId)
      this.showAlertDeleteProject()
      this.getData()
    },
    SuccessCountDownChanged (dismissCountDown) {
      this.success = dismissCountDown
    },
    ErrorCountDownChanged (dismissCountDown) {
      this.error = dismissCountDown
    },
    showAlertCreateProject () {
      this.massage = ''
      this.massage = 'Create a new project completed.'
      this.success = this.dismissSecs
    },
    showAlertUpdateProject () {
      this.massage = ''
      this.massage = 'Update a project completed.'
      this.success = this.dismissSecs
    },
    showAlertDeleteProject () {
      this.massage = ''
      this.massage = 'Delete a project completed.'
      this.success = this.dismissSecs
    },
    showAlertErrorCreateProject () {
      this.massage = ''
      this.massage = 'Somthing wrong, Please try again.'
      this.error = this.dismissSecs
    }
  },
  data () {
    return {
      perPage: 25,
      currentPage: 1,
      getProjects: [],
      pageName: 'Project List',
      // eslint-disable-next-line no-undef
      fields: [
        { key: 'id', sortable: true },
        { key: 'projectTitle', label: 'Project Name', sortable: true },
        { key: 'start', sortable: true },
        { key: 'end', sortable: true },
        { key: 'createBy', sortable: true },
        { key: 'actions', label: 'Actions' }
      ],
      editProject: [],
      projectTitle: '',
      projectDetail: '',
      start: '',
      end: '',
      modalViewProjectId: '',
      modalEdit: {
        id: 'edit-project',
        projectId: ''
      },
      modalDelete: {
        id: 'delete-project',
        projectId: ''
      },
      getViewProject: [],
      massage: '',
      dismissSecs: 3,
      dismissCountDown: 0,
      success: 0,
      error: 0
    }
  },
  computed: {
    rows () {
      return this.getProjects.length
    }
  }
}
</script>
